using System;

namespace com.agilefaqs.rft.domain
{
    public class Country
    {
        public virtual String Name
        {
            get { return name; }

            set { name = value; }
        }

        public virtual String Code
        {
            get { return code; }

            set { code = value; }
        }

        public virtual String Continent
        {
            get { return continent; }

            set { continent = value; }
        }

        /// <returns> the moniker
        /// </returns>
        public virtual String Moniker
        {
            get { return moniker; }
        }

        private String name;
        private String continent;
        private String code;
        private String moniker;

        public Country()
        {
        }

        public Country(String code, String name)
        {
            this.code = code;
            this.name = name;
        }

        public Country(String code, String name, String moniker)
        {
            this.code = code;
            this.name = name;
            this.moniker = moniker;
        }

        public override bool Equals(Object o)
        {
            if (this == o)
            {
                return true;
            }
            if (!o.GetType().Equals(GetType()))
            {
                return false;
            }

            Country country = (Country) o;

            if (code != null && code.Equals(country.Code) || name != null && name.Equals(country.Name))
            {
                return true;
            }

            return false;
        }

        public override int GetHashCode()
        {
            int result;
            result = name != null ? name.GetHashCode() : 0;
            result = 31*result + (code != null ? code.GetHashCode() : 0);
            return result;
        }

        public override String ToString()
        {
            return name;
        }
    }
}