using System;

namespace com.agilefaqs.rft.suggestions.strategies
{
    public class ChildStrategyParam
    {
        private String token1;
        private String token2;
        private String token3;
        
        public ChildStrategyParam(String firstToken, String secondToken, String userLastName)
        {
            token1 = firstToken;
            token2 = secondToken;
            token3 = userLastName;
        }

        public virtual String Token1
        {
            get { return token1; }
        }

        public virtual String Token2
        {
            get { return token2; }
        }

        public virtual String Token3
        {
            get { return token3; }
        }

        public override bool Equals(Object other)
        {
            if (this == other)
            {
                return true;
            }
            if (other == null)
            {
                return false;
            }

            if (!(other is ChildStrategyParam))
            {
                return false;
            }
            return equals((ChildStrategyParam) other);
        }

        private bool equals(ChildStrategyParam other)
        {
            convertNullsToEmpty(other);
            convertNullsToEmpty(this);
            return token1.Equals(other.token1) && token2.Equals(other.token2) && token3.Equals(other.token3);
        }

        private static void convertNullsToEmpty(ChildStrategyParam param)
        {
            if (param.token1 == null)
                param.token1 = "";
            if (param.token2 == null)
                param.token2 = "";
            if (param.token3 == null)
                param.token3 = "";
        }

        public override int GetHashCode()
        {
            return base.GetHashCode();
        }
    }
}