/// <summary> </summary>
using System;
using System.Collections.Generic;
using com.agilefaqs.rft.suggestions.strategies;

namespace com.agilefaqs.rft.suggestions
{
    public abstract class AbstractCommonSuggestionsStrategy
    {
        private readonly List<ChildSuggestionStrategy> childStrategies;

        public AbstractCommonSuggestionsStrategy(ChildSuggestionFactory childSuggestionFactory)
        {
            childStrategies = childSuggestionFactory.getStrategies();
        }

        public virtual String suggestedIdentity(ChildStrategyParam param)
        {
            foreach (ChildSuggestionStrategy childStrategy in childStrategies)
            {
                String Identity = childStrategy.generateId(param);
                if (Identity != null)
                {
                    return Identity;
                }
            }
            return null;
        }
    }
}