using System;
using System.Collections.Generic;
using RefactoringTeaser4sharp.suggestions;

namespace com.agilefaqs.rft.suggestions
{
    public class IdentityGenerator : AbstractIdentityGenerator
    {
        public IdentityGenerator(SuggestionStrategyFactory suggestionsFactory):base(suggestionsFactory.getStrategies())
        {
        }

        public override List<string> getGeneratedIDs(SuggestionParam suggestionParam)
        {
            List<string> suggestedIDs = new List<string>(TOTAL_SUGGESTIONS);
            foreach (SuggestionStrategy suggestionStrategy in identityGenerators)
            {
                String Identity = suggestionStrategy.getIdentity(suggestionParam);
                if (Identity != null)
                {
                    suggestedIDs.Add(Identity);
                }
            }
            return suggestedIDs;
        }
    }
}