using System;
using System.Text;
using System.Text.RegularExpressions;

namespace com.agilefaqs.rft.utils
{
    public class StringUtils
    {
        /// <param name="word">
        /// </param>
        /// <param name="allowedChars">
        /// </param>
        /// <returns>
        /// </returns>
        public static String removeSpecialCharactersIfAny(String word, char[] allowedChars)
        {
            int index = 0;
            int size = word.Length;
            string chars = "";
            foreach (char c in allowedChars)
            {
                chars += c;
            }
            StringBuilder filteredWord = new StringBuilder();
            if (word.StartsWith("-"))
            {
                index++;
            }
            if (word.EndsWith("-"))
            {
                size--;
            }
            while (index < size)
            {
                String letter = Convert.ToString(word[index++]);

                if (IsAlphanumeric(letter) || chars.Contains(letter))
                {
                    filteredWord.Append(letter);
                }
            }
            return filteredWord.ToString();
        }

        private static bool IsAlphanumeric(string letter)
        {
            Regex regex = new Regex("[^A-Za-z0-9]", RegexOptions.IgnoreCase);
            return !regex.IsMatch(letter);
        }
    }
}